<?php

define ("DEBUG_MODE", FALSE);
// Includes
include_once("./include/padfile.php");
include_once("./include/padvalidator.php");

// Read input
$URL = @$_POST["ValidateURL"];
if ( $URL == "" ) $URL = "http://";

// Print the form
?>
<form method='POST' action='<?php echo $_SERVER["PHP_SELF"]; ?>#validate'>
  PAD URL:
  <input type='text' name='ValidateURL' size='60' value='<?php echo $URL; ?>'>
  <input type='submit' value='Validate!'>
</form>
<p>
<?php

// Create PAD file object
$PAD = new PADFile($URL);

// If the form above has been posted, load the PAD file from the entered URL
if ( $URL != "http://" )
{
  echo "Loading <i>" . $PAD->URL . "</i> ... ";
  $PAD->Load();
  switch ( $PAD->LastError )
  {
    case ERR_NO_ERROR:
      echo "<span style=\"color:green\">OK</span>\n";
      flush();
      break;
    case ERR_NO_URL_SPECIFIED:
      echo "<br/><span style=\"color:red\">No URL specified.</span>";
      break;
    case ERR_READ_FROM_URL_FAILED:
      echo "<br/><span style=\"color:red\">Cannot open URL.";
      if ($PADFile->LastErrorMsg != "")
        echo " (" . $PADFile->LastErrorMsg . ")";
      echo "</span>";
      break;
    case ERR_PARSE_ERROR:
      echo "<br/><span style=\"color:red\">Parse Error: " . $PAD->ParseError . "</span>";
      break;
  }

  // Output
  echo "<h4>Validation Report for <i>" . $PAD->URL . "</i></h4>\n";

  // Create validator
  $PADValidator = new PADValidator("http://repository.appvisor.com/padspec/files/padspec.xml");
  if ( !$PADValidator->Load() )
  {
    echo "Error loading Validator.</br>";
    echo "Make sure to enable the allow_url_fopen PHP option.";
  }
  else
  {
    // Validate
    $nErrors = $PADValidator->Validate($PAD);
    if ( $nErrors == 0 )
      // No errors
      echo "<b><span style=\"color:green\">No Errors</span></b>";
    else
    {
      // Print validation errors
      echo "<b><span style=\"color:red\">" . $nErrors . " Errors</span></b>";
      foreach($PADValidator->ValidationErrors as $err)
      {
        echo "<p><b><span style=\"color:red\">Error:</span></b><br>";
        $err->Dump();
        echo "<br/>&nbsp;</p>";
      }
    }

    if ( DEBUG_MODE )
    {
      $nErrors = $PADValidator->ValidateRegEx($PAD);
      if ( $nErrors == 0 )
      {
        // No errors
        echo "<br/><br/>";
        echo "<b><span style=\"color:green\">No RegExp Errors</span></b>";
      }
      else
      {
        // Print validation errors
        echo "<br/><br/>";
        echo "<b><span style=\"color:red\">" . $nErrors . " Errors</span></b>";
        foreach($PADValidator->ValidationErrors as $err)
        {
          echo "<p><b><span style=\"color:red\">Error:</span></b><br>";
          $err->Dump();
          echo "<br/>&nbsp;</p>";
        }
      }
    }

  }
}

?>